stages:
  - update
  - build

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $CI_REGISTRY_IMAGE .
    - docker tag $CI_REGISTRY_IMAGE $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  tags:
    - docker
  rules:
    - if: $CI_COMMIT_TAG

update:
  image: python:latest
  stage: update
  variables:
    GIT_STRATEGY: clone
    GIT_DEPTH: 0
  before_script:
    - apt-get update -y
    - pip install -r requirements.txt
    - command -v ssh-agent || ( apt-get install -y openssh-client )
    - eval $(ssh-agent -s)
    - echo "${SSH_KEY}" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
    - git config user.name "FS-ETIT CI-Bot"
    - git config user.email "rechner@fs-etit.kit.edu"
  script:
    - git checkout $CI_COMMIT_REF_NAME
    - git remote set-url origin git@gitlab.com:${CI_PROJECT_PATH}.git
    - python3 update.py
    - git push origin $CI_COMMIT_REF_NAME
    - git push origin --tags
  rules:
    - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH
      when: never
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_PIPELINE_SOURCE == "web"
